# Grenzen & Größen endlicher Automaten
## Nerode-Index einer Sprache
- Sei $L=\{w ∈ \{x,y,z\}^*\}\space | \space \#_z(w) ∈ \{2,3\}\}$
- betrachte die Wörter aus $\{x, y, z\}^*$
  - Gruppiere sie hinsichtlich des "Grad der Zugehörigkeit" zu $L$
    - ![image_780.png](image_780.png)
- Beobachtung:
  - zwei Worte $u ∈ L$ und $v \not\in L$ sind sicherlich nicht sehr ähnlich
  - zwei Worte $u,v ∈ L$ _können_ ähnlich sein 
    - ähnlich: $zz$ und $yzxxzy$
    - nicht ähnlich: $zz$ und $zzz$
  - zwei Worte $u,v \not\in L$ _können_ ähnlich sein
    - ähnlich: $ ε$ und $xxy$
    - nicht ähnlich: $ ε$ und $yzxxxy$

- **$u,v ∈ Σ^*$ sind ähnlich bezüglich $L$, wenn:**
  - durch anhängigen des gleichen, beliebigen Wortes
    - in beiden Fällen ein Wort aus $L$ entsteht
    - in beiden Fällen ein Wort aus $Σ \backslash L$ entsteht

### Rechtsäquivalenz
- gegebene Sprache $L$ über Alphabet Σ
- $u,v ∈ Σ^*$ heißen rechtsäquivalent bezüglich L, wenn
  - $∀s ∈ Σ^*: u*s ∈ L ↔ v*s ∈ L$
- wir schreiben auch: $(u,v) ∈ R_L$ oder $u \space R_L \space v$

### Nerode-Klassen und -Index
- gegebene Sprache $L$ über Alphabet Σ und Wort $u ∈ Σ^*$
- **Nerode-Klasse $N(u)$**: Menge der zu $u$ rechtsäquivalenten Wörter:
  - $N(u) := \{v ∈ Σ^* \space | \space (u,v) ∈ R_L\}$
- **Nerode-Index** von L: Anzahl Nerode-Klassen

### Beispiel
- ist $v ∈ N(u)$ so gilt $N(v)=N(u)$
- beliebiges $u ∈ N$ heißt _Repräsentant_ der Nerode-Klasse $N$

- Wie lauten die Nerode-Klassen von der Sprache $L_1 = \{w ∈ \{x,y,z\}^* \space | \space \#_Z(w) ∈ \{2,3\}\}$?
  - ![image_781.png](image_781.png)
- Wie viele Nerode-Klassen hat $L_2=\{0^n*1^n \space | \space n ∈ N_0\}$
  - ∞
  - bspw. $N_i=N(0^i)$ für $i ∈ N_0$
## Eigenschaften von Nerode-Klassen
## Der Satz von Myhill-Nerode
## Reaping the Fruits!
## Minimierungsalgorithmus
